class PanelPicture < ActiveRecord::Base
  belongs_to :panel
  belongs_to :resource_picture
  
  validates :width, :presence => true, :numericality => true, :not_zero => true
  validates :height, :presence => true, :numericality => true, :not_zero => true
  
  def flip
    res = (self.height < 0 ? '' : 'v') + (self.width == 0 ? '' : 'h')
    res += '/' unless res.empty?
    res
  end
  
  def filename
    flip + self.resource_picture.filename
  end
  
  def url
    '/resource_pictures/' + filename
  end
  
end
