require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe OriginalLicensesController do

  # This should return the minimal set of attributes required to create a valid
  # OriginalLicense. As you add validations to OriginalLicense, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all original_licenses as @original_licenses" do
      original_license = OriginalLicense.create! valid_attributes
      get :index
      assigns(:original_licenses).should eq([original_license])
    end
  end

  describe "GET show" do
    it "assigns the requested original_license as @original_license" do
      original_license = OriginalLicense.create! valid_attributes
      get :show, :id => original_license.id
      assigns(:original_license).should eq(original_license)
    end
  end

  describe "GET new" do
    it "assigns a new original_license as @original_license" do
      get :new
      assigns(:original_license).should be_a_new(OriginalLicense)
    end
  end

  describe "GET edit" do
    it "assigns the requested original_license as @original_license" do
      original_license = OriginalLicense.create! valid_attributes
      get :edit, :id => original_license.id
      assigns(:original_license).should eq(original_license)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new OriginalLicense" do
        expect {
          post :create, :original_license => valid_attributes
        }.to change(OriginalLicense, :count).by(1)
      end

      it "assigns a newly created original_license as @original_license" do
        post :create, :original_license => valid_attributes
        assigns(:original_license).should be_a(OriginalLicense)
        assigns(:original_license).should be_persisted
      end

      it "redirects to the created original_license" do
        post :create, :original_license => valid_attributes
        response.should redirect_to(OriginalLicense.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved original_license as @original_license" do
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalLicense.any_instance.stub(:save).and_return(false)
        post :create, :original_license => {}
        assigns(:original_license).should be_a_new(OriginalLicense)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalLicense.any_instance.stub(:save).and_return(false)
        post :create, :original_license => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested original_license" do
        original_license = OriginalLicense.create! valid_attributes
        # Assuming there are no other original_licenses in the database, this
        # specifies that the OriginalLicense created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        OriginalLicense.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => original_license.id, :original_license => {'these' => 'params'}
      end

      it "assigns the requested original_license as @original_license" do
        original_license = OriginalLicense.create! valid_attributes
        put :update, :id => original_license.id, :original_license => valid_attributes
        assigns(:original_license).should eq(original_license)
      end

      it "redirects to the original_license" do
        original_license = OriginalLicense.create! valid_attributes
        put :update, :id => original_license.id, :original_license => valid_attributes
        response.should redirect_to(original_license)
      end
    end

    describe "with invalid params" do
      it "assigns the original_license as @original_license" do
        original_license = OriginalLicense.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalLicense.any_instance.stub(:save).and_return(false)
        put :update, :id => original_license.id, :original_license => {}
        assigns(:original_license).should eq(original_license)
      end

      it "re-renders the 'edit' template" do
        original_license = OriginalLicense.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        OriginalLicense.any_instance.stub(:save).and_return(false)
        put :update, :id => original_license.id, :original_license => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested original_license" do
      original_license = OriginalLicense.create! valid_attributes
      expect {
        delete :destroy, :id => original_license.id
      }.to change(OriginalLicense, :count).by(-1)
    end

    it "redirects to the original_licenses list" do
      original_license = OriginalLicense.create! valid_attributes
      delete :destroy, :id => original_license.id
      response.should redirect_to(original_licenses_url)
    end
  end

end
