require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SystemPicturesController do

  # This should return the minimal set of attributes required to create a valid
  # SystemPicture. As you add validations to SystemPicture, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all system_pictures as @system_pictures" do
      system_picture = SystemPicture.create! valid_attributes
      get :index
      assigns(:system_pictures).should eq([system_picture])
    end
  end

  describe "GET show" do
    it "assigns the requested system_picture as @system_picture" do
      system_picture = SystemPicture.create! valid_attributes
      get :show, :id => system_picture.id
      assigns(:system_picture).should eq(system_picture)
    end
  end

  describe "GET new" do
    it "assigns a new system_picture as @system_picture" do
      get :new
      assigns(:system_picture).should be_a_new(SystemPicture)
    end
  end

  describe "GET edit" do
    it "assigns the requested system_picture as @system_picture" do
      system_picture = SystemPicture.create! valid_attributes
      get :edit, :id => system_picture.id
      assigns(:system_picture).should eq(system_picture)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new SystemPicture" do
        expect {
          post :create, :system_picture => valid_attributes
        }.to change(SystemPicture, :count).by(1)
      end

      it "assigns a newly created system_picture as @system_picture" do
        post :create, :system_picture => valid_attributes
        assigns(:system_picture).should be_a(SystemPicture)
        assigns(:system_picture).should be_persisted
      end

      it "redirects to the created system_picture" do
        post :create, :system_picture => valid_attributes
        response.should redirect_to(SystemPicture.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved system_picture as @system_picture" do
        # Trigger the behavior that occurs when invalid params are submitted
        SystemPicture.any_instance.stub(:save).and_return(false)
        post :create, :system_picture => {}
        assigns(:system_picture).should be_a_new(SystemPicture)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        SystemPicture.any_instance.stub(:save).and_return(false)
        post :create, :system_picture => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested system_picture" do
        system_picture = SystemPicture.create! valid_attributes
        # Assuming there are no other system_pictures in the database, this
        # specifies that the SystemPicture created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        SystemPicture.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => system_picture.id, :system_picture => {'these' => 'params'}
      end

      it "assigns the requested system_picture as @system_picture" do
        system_picture = SystemPicture.create! valid_attributes
        put :update, :id => system_picture.id, :system_picture => valid_attributes
        assigns(:system_picture).should eq(system_picture)
      end

      it "redirects to the system_picture" do
        system_picture = SystemPicture.create! valid_attributes
        put :update, :id => system_picture.id, :system_picture => valid_attributes
        response.should redirect_to(system_picture)
      end
    end

    describe "with invalid params" do
      it "assigns the system_picture as @system_picture" do
        system_picture = SystemPicture.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SystemPicture.any_instance.stub(:save).and_return(false)
        put :update, :id => system_picture.id, :system_picture => {}
        assigns(:system_picture).should eq(system_picture)
      end

      it "re-renders the 'edit' template" do
        system_picture = SystemPicture.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SystemPicture.any_instance.stub(:save).and_return(false)
        put :update, :id => system_picture.id, :system_picture => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested system_picture" do
      system_picture = SystemPicture.create! valid_attributes
      expect {
        delete :destroy, :id => system_picture.id
      }.to change(SystemPicture, :count).by(-1)
    end

    it "redirects to the system_pictures list" do
      system_picture = SystemPicture.create! valid_attributes
      delete :destroy, :id => system_picture.id
      response.should redirect_to(system_pictures_url)
    end
  end

end
